<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/admin_batchadd.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
| 
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/  

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");
require_once(e_HANDLER."form_handler.php");

/*
 * get some vars
 */
list($category) = explode(".", e_QUERY);
$category = intval($category);
extract($_POST['setup']);
extract($_POST['imagelist']);
$frm = new form;

/*
 * check the vars
 */
if ($category <= 0) $category = 1;
if (!isset($setup['category_id']) || $setup['category_id'] == "") $setup['category_id'] = $category;
if (!isset($setup['category_name']) || $setup['category_name'] == ""){
  $sql->db_Select("images_category", "category_name", "category_id=".$setup['category_id']);
  list($setup['category_name']) = $sql->db_Fetch();
}
if (!isset($setup['mode']) || $setup['mode'] == "") $setup['mode'] = "add";
if ($setup['mode'] == "new"){
  if (!isset($setup['new_category_name']) || $setup['new_category_name'] == "") $setup['new_category_name'] = "Subcategory";
  if (!isset($setup['category_description']) || $setup['category_description'] == "") $setup['category_description'] = "The admin is too lazy to type a description";
}
if (!isset($setup['path'])){
  $setup['path'] = "upload/";
} else if (substr($setup['path'], -1) != "/"){
  $setup['path'] .= "/";
}

/* check authorisation */
if(!is_authorized($category, "admin") && !getperms("P")){
  header("location:".e_BASE."index.php");
  exit;
}

/*
 * add the images
 */
if (isset($_POST['add'])){
  $message = add_images($setup, $imagelist);
}

/*
 * render the page
 */
$mytxt = render_page($setup, $imagelist);

/*
 * now display the page
 */
require_once(e_ADMIN."auth.php");
if ($message){
  $ns->tablerender("Batch add results", $message);
}
$ns->tablerender("Batch add images", $mytxt);
require_once(e_ADMIN."footer.php");

/*******************************************************************/

/* render the page by putting the parts together
 */
function render_page($setup, $imagelist){
  global $frm;

  $text = $frm->form_open("post", e_SELF);
  $text .= render_setup($setup);
  $text .= "<br /><br />";
  $text .= render_images($setup['path'], $imagelist);
  $text .= $frm->form_close();

  return $text;
}

/* render the settings form for the batch add
 */
function render_setup($setup){
  global $sql, $setup, $frm;
  $tp = new textparse;
  
  foreach ($setup as $key => $value){
    $setup[$key] = $tp->formtpa($value);
  }
  
  $addselected = $setup['mode'] == "add" ? 1 : 0;

  /* get a list of paths available with images */
  $paths = get_paths();

  /* find out the category name */

  $category = $setup['category_id']." - ".$setup['category_name'];

  /* check if there is something wrong with the current settings */
  $error = check_settings($setup);

  /**/
  $text = $frm->form_hidden("setup[category_id]", $setup['category_id']);
  $text .= $frm->form_hidden("setup[category_name]", $setup['category_name']);
  $text .= "<table style='width:100%'>
  	      <tr>
	        <td colspan='2' class='forumheader'>Batch add settings<td>
	      </tr>
              <tr>
	        <td class='forumheader3' style='width: 40%;'>
		  Image path<br />
		  <span class='smalltext'>This is the full path to the images. Images will be <b>removed</b> from this folder. Upload your images now if you haven't done so allready</span>
		</td>
	        <td class='forumheader3'>". e_FILE . "imagegallery/";
  /* display the list of available paths with images
   */
  $text .= $frm->form_select_open("setup[path]");
  foreach ($paths as $path){
    $text .= $frm->form_option($path, ($path."/" == $setup['path'] ? 1 : 0), $path);
  }
  $text .= $frm->form_select_close();
  /**/
  $text .=     "</td>
	      </tr>";
  /* check if the selected path is writable
   */
  if ($error[0]) {
    $text .= "<tr><td colspan='2' class='forumheader2'>The folder <b>'".e_FILE."imagegallery/".$setup['path']."'</b> is <b>not</b> writable! Make this folder writabe before you continue!</td></tr>";
  }
  /**/
  $text .=   "<tr>
	        <td colspan='2' class='forumheader3'>";
  $text .= $frm->form_radio("setup[mode]", "add", $addselected);
  $text .=       "Add the images to existing category<br />
  		  <span class='smalltext'>Images will be added to the existing category '$category'</span>
  		</td>
	      </tr>";
  /* if the images are being added to an existing category,
   * check ik the categories folder is writable
   */
  if ($addselected && $error[1]) {
    $text .= "<tr><td colspan='2' class='forumheader2'>The folder <b>'".e_FILE."imagegallery/$category'</b> is <b>not</b> writable! Make this folder writabe before you continue!</td></tr>";
  }
  /**/
  $text .=   "<tr>
	        <td class='forumheader3'>";
  $text .= $frm->form_radio("setup[mode]", "new", !$addselected);
  $text .=       "Add the images to a new category<br />
  		  <span class='smalltext'>A new subcategory will be created for the images to be added in</spam>
	        </td>
	        <td class='forumheader3'> New category name:<br />";
  $text .= $frm->form_text("setup[new_category_name]", 35, $setup['new_category_name'], 100);
  $text .= "<br />New category description<br />";
  $text .= $frm->form_textarea("setup[category_description]", 50, 4, $setup['category_description']);
  $text .=   "</td>
	      </tr>";
  /* if a new subcategory should be made, check to
   * see if a folder for the new category can be made
   * and if the category name allready exists for
   * this category
   */
  if (!$addselected && $error[3]) {
    $text .= "<tr><td colspan='2' class='forumheader2'>A subcategory called '<b>".$setup['new_category_name']."</b>' allready exists in this category!</td></tr>";
  }
  /**/
  if (!$addselected && $error[2]) {
    $text .= "<tr><td colspan='2' class='forumheader2'>The folder <b>'".e_FILE."imagegallery'</b> is <b>not</b> writable! Make this folder writabe before you continue!</td></tr>";
  }
  /**/
  $text .=   "<tr><td colspan='2'></td></tr>
              <tr>
	        <td colspan='2' style='text-align: center;'>";
  $text .= $frm->form_button("submit", "refresh", "Refresh");
  $text .= $frm->form_button("submit", "add", "Add images");
  $text .=   "</td>
	      </tr>
	    </table>";

  return $text;
}

/* for each image found in $path, display a part of the form
 */
function render_images($path, $imagelist){
  /* get the list of images */
  $images = get_images($path);

  $text = "<table width='100%'>";
  $text .= render_header();

  /* render the list of images, or an message if none were found */
  if (count($images)){
    foreach($images as $image){
      if (!isset($imagelist[$image])) {
        $imagelist[$image]['image'] = $image;
        $imagelist[$image]['path'] = $path;
        $imagelist[$image]['name'] = $image;
        $imagelist[$image]['description'] = $image;
        $imagelist[$image]['filesize'] = filesize(e_FILE."imagegallery/".$imagelist[$image]['path'].$imagelist[$image]['image']);
        $imagelist[$image]['filedetails'] = parseimagedetails(e_FILE."imagegallery/".$imagelist[$image]['path'].$imagelist[$image]['image']);
      }
      $text .= render_image($imagelist[$image]);
    }
  } else {
    $text .= "<tr><td colspan='3' class='forumheader3'>No Images found in '$path'</td></tr>";
  }
  $text .= "</table>";
  
  return $text;
}

/* render a header for the images which can be added
 */
function render_header(){
  return "<tr>
  	   <td class='forumheader'>Add?</td>
	   <td class='forumheader'>Name / Description</td>
	   <td class='forumheader'>Preview</td>
	  </tr>";
}

/* render one image which can be added
 */
function render_image($img){
  global $frm;
  $tp = new textparse;

  foreach ($img as $key => $value){
    $img[$key] = $tp->formtpa($value);
  }
  
  $img_img = $img['image'];
  $img_add = (isset($img['add'])) ? 1 : 0;
 
  $text  = $frm->form_hidden("imagelist[$img_img][image]", $img['image']);
  $text .= $frm->form_hidden("imagelist[$img_img][path]", $img['path']);
  $text .= $frm->form_hidden("imagelist[$img_img][filesize]", $img['filesize']);
  $text .= $frm->form_hidden("imagelist[$img_img][filedetails]", $img['filedetails']);
  $text .= "<tr>
  	     <td rowspan='2' class='forumheader3'>";
  $text .= $frm->form_checkbox("imagelist[$img_img][add]", "yes", $img_add);
  $text .=  "</td>
  	     <td class='forumheader3'>";
  $text .= $frm->form_text("imagelist[$img_img][name]", 50, $img['name'], 100);
  $text .=  "</td>
  	     <td rowspan='2' class='forumheader3' style='text-align: center; vertical-align: middle'>
	       <a href='".e_FILE."imagegallery/". $img['path'] . $img['image']. "'>
	         <img src='admin_preview.php?". $img['path'] . $img['image']. "' alt='Click for a preview'/>
	       </a><br />";
  $text .= $img['filesize']." bytes<br />";
  $text .= $img['filedetails'];
  $text .=  "</td>
  	   </tr>
	   <tr>
  	     <td class='forumheader3'>";
  $text .= $frm->form_textarea("imagelist[$img_img][description]", 50, 4, $img['description']);
  $text .=  "</td>
	   </tr>";

  return $text;
}

/* Add the images to the gallery
 */
function add_images($setup, $images){
  $good = $bad = 0;

  if (!image_selected($images)) return "No image was selected, batchadd aborted";

  if ($setup['mode'] == "new"){
    /* create the new category */
    if ($setup['category_id'] = add_category($setup['new_category_name'], $setup['category_description'], $setup['category_id'])){
      $setup['category_name'] = $setup['new_category_name'];
    } else {
      return "unable to create the new category, batchadd aborted!";
    }
  }
 
  foreach ($images as $image){
    /*todo buiten de foreach halen en merge array gebruiken */
    $image['author'] = USERNAME;
    $image['author_email'] = USEREMAIL;
    $image['author_website'] = "http://unkie.org";
    $image['thumb'] = preg_replace('/(.+)(\.[a-z]{3})/i', '\1_thumb\2', $image['image']);
    $image['category'] = $setup['category_id'];
    $image['newpath'] = $setup['category_id']."-".$setup['category_name']."/";
    if (isset($image['add'])){
      if (add_image($image)){
        $good++;
      } else {
        $bad++;
      }
    }
  }

  return "$good image(s) were successfully added, $bad image(s) failed.";
}

/* check if an image is selected for adding
 */
function image_selected($images){
  foreach ($images as $image){
    if (isset($image['add'])) return true;
  }
  return false;
}

/* add one new category
 */
function add_category($name, $description, $parent){
  global $sql, $pref;
  $tp = new textparse;

  /* check if a category with this name already exits in the parent category */
  if ($sql->db_Count("images_category", "(*)", "WHERE category_category = $parent AND category_name = $name")) return false;

  /* get some defaults from the parent */
  if (!$sql->db_Select("images_category", "category_image, category_class_view, category_class_submit, category_class_admin, category_mode", "category_id = $parent")) return false;
  list($category_image, $category_class_view, $category_class_submit, $category_class_admin, $category_mode) = $sql->db_Fetch();

  $name = $tp->formtp($name);
  $description = $tp->formtp($description);

  if (!$sql->db_Insert("images_category", "0, '$name', '$description', '$category_image', $parent, $category_class_view,$category_class_submit,$category_class_admin, '$category_mode'")){
    return false;
  } else {
    /* get new category's id */
    $sql->db_Select("images_category", "category_id", "category_name = '$name' AND category_category = $parent");
    list($category_id) = $sql->db_Fetch();
  }
  if (!mkdir(e_FILE."imagegallery/".$category_id."-".$name, octdec($pref['ig_folder_perms']))){
    /* undo the db_Insert*/
    $sql->db_Delete("images_category", "category_name = '$name' AND category_category = $parent");
    return false; 
  }

  return $category_id;
}

/* add one image to the database
 */
function add_image($image){
  global $sql;
  $tp = new textparse;
  require_once(e_HANDLER."resize_handler.php");

  if (!resize_image(e_FILE."imagegallery/".$image['path'].$image['image'], e_FILE."imagegallery/".$image['newpath'].$image['thumb'])) return false;
  
  if (!rename(e_FILE."imagegallery/".$image['path'].$image['image'], e_FILE."imagegallery/".$image['newpath'].$image['image'])){
    /* undo if something fails */
    unlink( e_FILE."imagegallery/".$image['newpath'].$image['thumb']);
    return false;
  }
  
  foreach ($image as $key => $value){
    $image[$key] = $tp->formtp($value);
  }
  
  if (!$sql->db_Insert("images", "0, '".$image['name']."', '".$image['description']."', '".$image['thumb']."', '".$image['image']."', ".time().", ".$image['category'].", '".$image['author']."', '".$image['author_email']."', '".$image['author_website']."', 0, 0")){
    /* undo if something fails */
    rename(e_FILE."imagegallery/".$image['newpath'].$image['image'], e_FILE."imagegallery/".$image['path'].$image['image']);
    unlink( e_FILE."imagegallery/".$image['newpath'].$image['thumb']);
    return false;  
  }
  return true;
}

/* get a list of the images in a folder
 */
function get_images($folder) {
  $dir = opendir(e_FILE . "imagegallery/" . $folder);
  $list = array();

  while(false !== ($file = readdir($dir))){
    if (is_dir($folder.$file)){
      /* do nothing */
    } elseif ($file != "." && $file != ".." && is_image(e_FILE."imagegallery/".$folder.$file)){
      /* add to the list */
      $list[] = $file;
    }
  }
  closedir($dir);

  /* sort the list */
  natcasesort($list);

  return $list;
}

function get_paths(){
  $dir = opendir(e_FILE . "imagegallery/");
  $list = array();
  while (false !== ($file = readdir($dir))){
    if ($file != "." && $file != ".." && is_dir(e_FILE."imagegallery/".$file) && !is_category_name($file)){
      $list[] = $file;
    }
  }
  closedir($dir);

  /* sort the list */
  natcasesort($list);

  return $list;
}

function is_image($file){
  $image_stats = getimagesize($file);
  if($image_stats == null) return false;
  return true;
}

/* checks if the given $categ_name is the name of an existing category folde
 */
function is_category_name($category_name){
  global $sql;

  if ($category_name == "category_thumbs") return true;
  return ($sql->db_Count("images_category", "(category_id)", "WHERE CONCAT(category_id, '-', category_name) = '$category_name';"));
}

/* check if there is something wrong with the $setup
 */
function check_settings($setup){
  global $sql;
  if (!is_writable(e_FILE."imagegallery/".$setup['path'])) $error[0] = true;

  if (!is_writable(e_FILE."imagegallery/".$setup['category_id']."-".$setup['category_name'])) $error[1] = true;

  if (!is_writable(e_FILE."imagegallery")) $error[2] = true;
  
  $sql->db_Select_gen("SELECT count(*)
  	FROM ".MPREFIX."images_category cat 
		INNER JOIN ".MPREFIX."images_category subcat ON cat.category_id = subcat.category_category
	WHERE cat.category_id = ".$setup['category_id']." AND subcat.category_name = '".$setup['new_category_name']."'");
  list($count) = $sql->db_Fetch();
  
  if ($count) $error[3] = true;

  return isset($error) ? $error : false;
}

?>
