<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/browse.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");

/*
 * which category are we administering
 */
list($category) = explode(".", e_QUERY);
$category = intval($category);

/*
 * check the vars
 */
if ($category <= 0) $category = 1;

/* check authorisation */
if(!is_authorized($category, "admin") && !getperms("P")){
  header("location:".e_BASE."index.php");
  exit;
}

/*
 * render the options bar, categories and images
 */
$cattxt = render_categories($category);
$imgtxt = render_images($category);
if ($cattxt == "" && $imgtxt == ""){
  $opttxt = render_none();
} else {
  $opttxt = render_opts();
}

/*
 * now display the page
 */
require_once(e_ADMIN."auth.php");
$ns->tablerender("Imagegallery Administration", render_page($opttxt.$cattxt.$imgtxt));
require_once(e_ADMIN."footer.php");

/*******************************************************************/

/* put it all together */
function render_page($txt){
  return "<table style='width: 100%;'>
  	   $txt
  	 </table>";
}

/* render categories */
function render_categories($category){
  $sql = new DB;

  $category_count = $sql->db_Select("images_category", "category_id, category_name", "category_category=$category");

  $mytxt = render_parent($category);
  if ($category_count){
    /* for every category render a row */
    for ($i = 0; $i < $category_count; $i++){
      $mytxt .= render_category($sql->db_Fetch());
    }
  }
  return $mytxt;
}
 

/* render images */
function render_images($category){
  $sql = new DB;

  $image_count = $sql->db_Select("images", "img_id, img_name, img_category", "img_category=$category");
  
  if ($image_count){
    $mytxt = "";
    /* for every category render a row */
    for ($i = 0; $i < $image_count; $i++){
      $mytxt .= render_image($sql->db_Fetch());
    }
    return $mytxt;
  } else {
    return false;
  }
}

/* render a row for a category */
function render_category($data){
  extract($data);

  $img = e_IMAGE."filemanager/folder.png";
  $category_opts = render_category_opts($category_id);
  return "<tr>
  	    <td class='forumheader3'><img src='$img' alt='$category_name' /></td>
	    <td class='forumheader3'>$category_id</td>
	    <td class='forumheader3'>
	      <a href='admin_browse.php?$category_id'>$category_name</a>
	    </td>
	    <td class='forumheader3'>$category_opts</td>
          </tr>";
}

/* render a row for the parent category */
function render_parent($category){
  $img = e_IMAGE."filemanager/folder.png";
  $sql = new DB;

  if ($category == 1){
    return;
  } else {
    $sql->db_Select("images_category", "category_category AS category", "category_id=$category");
    extract($sql->db_Fetch());
  }
  
  return "<tr>
  	    <td class='forumheader3'><img src='$img' alt='parent category' /></td>
	    <td class='forumheader3'>...</td>
	    <td class='forumheader3' colspan='2'>
	      <a href='admin_browse.php?$category'>Parent category</a>
	    </td>
  	  </tr>";
}

/* render a row for an image */
function render_image($data){
  extract($data);

  $img = e_IMAGE."filemanager/png.png";
  $img_opts = render_image_opts($img_id, $img_category);
  return "<tr>
  	    <td class='forumheader3'><img src='$img' alt='$img_name' /></td>
	    <td class='forumheader3'>$img_id</td>
	    <td class='forumheader3'>$img_name</td>
	    <td class='forumheader3'>$img_opts</td>
          </tr>";
}

function render_header(){
  return "<tr>
  	   <td class='forumheader' style='width: 5%;'>
	     <img src='". e_IMAGE."filemanager/updir.png' alt='up one category' />
	   </td>
  	   <td class='forumheader' style='width: 10%;'><b>id</b></td>
  	   <td class='forumheader' style='width: 30%;'><b>name</b></td>
  	   <td class='forumheader'><b>options</b></td>
	 </tr>";
}

function render_none(){
  return "<tr>
	   <td colspan='4' class='forumheader3'>No images and categories found in this category</td>
	 </tr>";
}

function render_opts($category){
  return "<tr>
	   <td colspan='4' class='forumheader3'>GET GIRLFRIEND - <a href='admin_batchadd.php?$category'>batch add images</a> - MAKE COFFEE</td>
	 </tr>" . render_header();
}

function render_category_opts($category_id){
  return " <a href='admin_details?cat.$category_id'>details</a> - <a href='admin_del.php?$category_id.0'>delete</a>";
}

function render_image_opts($image_id, $image_category){
  return " <a href='admin_details?img.$image_id'>details</a> - <a href='admin_del.php?$image_category.$image_id'>delete</a>";
}
