<?php
/*
+---------------------------------------------------------------+
|        e107 website system
|        //prefs.php
|
|        Steve Dunstan 2001-2002
|        http://e107.org
|        jalist@e107.org
|
|        Released under the terms and conditions of the
|        GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/
require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* check authorisation */
if(!getperms("P")){
  header("location:".e_BASE."index.php"); 
  exit;
}
  
/* save the preferences */
if(IsSet($_POST['updateprefs'])){
  $aj = new textparse;

  /* settings for thumbnail browse mode */
  $pref['ig_items_per_row']	= $_POST['ig_items_per_row'];
  $pref['ig_rows_per_page']	= $_POST['ig_rows_per_page'] ? $_POST['ig_rows_per_page'] : 4;
  $pref['ig_thumbnail_width']	= $_POST['ig_thumbnail_width'] ? $_POST['ig_thumbnail_width'] : 180;
  $pref['ig_folder_perms']	= $_POST['ig_folder_perms'] ? $_POST['ig_folder_perms'] : "0755";
  
  $sql -> db_Delete("cache");
  save_prefs();

  $sql -> db_Update("images_category", "category_mode='".$_POST['ig_mode_view'].".".$_POST['ig_mode_img'].".".$_POST['ig_mode_cat']."' WHERE category_id=1");
  header("Location: admin_config.php");
  echo "<script type='text/javascript'>document.location.href='admin_config.php'</script>\n";
  exit;
}

require_once(e_ADMIN."auth.php");
$ns->tablerender("Imagegallery configuration", render_configuration($pref));
require_once(e_ADMIN."footer.php");

/*********************************************************************/

/* render the configuration form */
function render_configuration($pref){
  require_once(e_HANDLER."form_handler.php");
  require_once("functions.php");
  $frm = new form;
  $mode = get_default_mode(1);
  
  $txt = $frm->form_open("post", e_SELF);
  $txt .= "<table style='width: 95%;' class='fborder'>
  	    <tr><td class='forumheader' colspan='2'>General settings</td></tr>
  	    <tr>
	      <td class='forumheader3'>
	        Thumbnail width<br />
		<span class='smalltext'>Newly generated thumbnails will be resized to fit this width. The optimal setting is at least the width of the other thumbnail width options.</span>
	      </td>
	      <td class='forumheader3'>";
  $txt .= $frm->form_text("ig_thumbnail_width", 3, $pref['ig_thumbnail_width']);
  $txt .=    "</td>
  	    </tr>
  	    <tr>
	      <td class='forumheader3'>
	        Category folder permissions<br />
		<span class='smalltext'>When new category's are created, a folder is made to store the images. This setting defines the permissions which are set on the newly created folder. Only change this setting if you know what you are doing!</span>
	      </td>
	      <td class='forumheader3'>";
  $txt .= $frm->form_text("ig_folder_perms", 4, $pref['ig_folder_perms']);
  $txt .=    "</td>
  	    </tr>
  	    <tr>
	      <td class='forumheader3'>
	        Default category, image and image view modes<br />
		<span class='smalltext'>These are the default display modes for browsing category's and images and for viewing images. These settings only apply to new child category's of the root category. For other new child category's of a category the default modes of that category are used. The modes of a certain category can be changed on the category details administration page of that category.</span>
	      </td>
	      <td class='forumheader3'>
	        Category's<br />";
  $txt .= mode_category_list('ig_mode_cat', $mode['cat']);
  $txt .= "<br />Images<br />";
  $txt .= mode_image_list('ig_mode_img', $mode['img']);
  $txt .= "<br />View<br />";
  $txt .= mode_view_list('ig_mode_view', $mode['view']);
  $txt .=    "</td>
  	    </tr>
  	    <tr><td class='forumheader' colspan='2'>Thumbnail gallery modes settings</td></tr>
  	    <tr>
	      <td class='forumheader3'>Thumbnails per row</td>
	      <td class='forumheader3'>";
  $txt .= $frm->form_select_open("ig_items_per_row");
  for ($i = 1; $i < 11; $i++){
    $txt .= $frm->form_option($i,($pref['ig_items_per_row'] == $i ? 1 : 0),$i);
  }
  $txt .= $frm->form_select_close();
  $txt .=    "</td>
  	    </tr>
  	    <tr>
	      <td class='forumheader3'>Rows of thumbnails</td>
	      <td class='forumheader3'>";
  $txt .= $frm->form_text("ig_rows_per_page", 2, $pref['ig_rows_per_page']);
  $txt .=    "</td>
  	    </tr>
  	    <tr>
	      <td class='forumheader3'>
	        Thumbnail width<br />
		<span class='smalltext'>While viewing a category in the standard gallery mode thumbnails will be show with this width</span>
	      </td>
	      <td class='forumheader3'>";
  $txt .= $frm->form_text("ig_thumbnail_gallery_width", 3, $pref['ig_thumbnail_gallery_width']."doesnt do anything");
  $txt .=    "</td>
  	    </tr>
  	    <tr><td class='forumheader' colspan='2'>Save settings</td></tr>
	    <tr>
	      <td colspan='2' style='text-align: center;' class='forumheader3'>";
  $txt .= $frm->form_button("submit", "updateprefs", "Save");
  $txt .=    "</td>
	    </tr>
  	  </table>";
  $txt .= $frm->form_close();

  return $txt;
}
?>
