<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/browse.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");

/*
 * which category are we administering
 */
list($category, $image) = explode(".", e_QUERY);
$category = intval($category);
$image = intval($image);

/*
 * check the vars
 */
if ($image == 0 && $category == 1) $category = 0;

/* check authorisation */
if($category == 0 || $image < 0 || (!is_authorized($category, "admin") && !getperms("P"))){
  header("location:".e_BASE."index.php");
  exit;
}

/*
 * check if cancel or delete was clicked
 */
if (isset($_POST['cancel'])){

  $sql->db_Select("images_category", "category_category AS category", "category_id=$category");
  extract($sql->db_Fetch());

  header("location: admin_browse.php?$category");

} else if (isset($_POST['delete'])){

  if ($image){
    /*TODO 1 functie hiervoor, als image argument >= dan query voor images aanpassen */
    $mytxt = delete_image($image, $category, $_POST['method_img']);
  } else {
    $mytxt = delete_category($category, $_POST['method_cat'], $_POST['method_img']);
  }
/* render deletion config form */
} else {
 
  require_once(e_HANDLER."form_handler.php");

  if ($image){
    $mytxt = render_image($image, $category);
  } else {
    $mytxt = render_category($category);
  }
}

/*
 * now display the page
 */
require_once(e_ADMIN."auth.php");
$ns->tablerender("Imagegallery Administration", $mytxt);
require_once(e_ADMIN."footer.php");

/*******************************************************************/

/* show the delete form for categories */
function render_category($category){
  $sql = new DB;
  $frm = new form;

  $category_count = $sql->db_Select_gen("SELECT cat.category_id, cat.category_name, COUNT(img.img_id) as category_images FROM ".MPREFIX."images_category AS cat LEFT JOIN ".MPREFIX."images AS img ON cat.category_id = img.img_category WHERE category_id=$category GROUP BY cat.category_id");

  if ($category_count){
    extract($sql->db_Fetch());

    $mytxt = $frm->form_open("post", e_SELF."?".e_QUERY);
    $mytxt .= "<table style='width: 95%;' class='fborder'>
                <tr>
		  <td class='forumheader' colspan='2'>Options for deleting a category</td>
		<tr>
		</tr>
		  <td class='forumheader3'>When deleting subcategories</td>
		  <td class='forumheader3'>";
    $mytxt .= $frm->form_select_open("method_cat");
    $mytxt .= $frm->form_option("Move to this category's parent category",1,"move");
    $mytxt .= $frm->form_option("Recursively delete",0,"delete");
    $mytxt .= $frm->form_select_close();
    $mytxt .=    "</td>
    		<tr>
    		</tr>
		  <td class='forumheader3'>When deleting images</td>
		  <td class='forumheader3''>";
    $mytxt .= $frm->form_select_open("method_img");
    $mytxt .= $frm->form_option("Move to the upload folder",1,"move");
    $mytxt .= $frm->form_option("Move to this category's parent category",0,"moveup");
    $mytxt .= $frm->form_option("Permanently delete",0,"delete");
    $mytxt .= $frm->form_select_close();
    $mytxt .=     "</td>
    		 <tr>
		 <tr>
		   <td style='text-align: center;' class='forumheader3' colspan='2'>";
    $mytxt .= $frm->form_button("submit", "delete", "Delete");
    $mytxt .= $frm->form_button("submit", "cancel", "Cancel");
    $mytxt .=     "</td>
		 </tr>
	      </table>";
    $mytxt .= $frm->form_close();

    return $mytxt;
  } else {
    return "The category you are trying to delete does not exist!";
  }
}

function render_image($image, $category){
  $sql = new DB;
  $frm = new form;
  
  $image_exists = $sql->db_Select("images", "img_id, img_name, img_views", "img_id=$image AND img_category=$category");

  if ($image_exists) {
    extract($sql->db_Fetch());

    $mytxt = $frm->form_open("post", e_SELF."?".e_QUERY);
    $mytxt .= "<table style='width: 95%;' class='fborder'>
    		 <tr>
		   <td class='forumheader' colspan='2'>Options for deleting an image</td>
		 </tr>
		 <tr>
		   <td class='forumheader3'>How to delete this image</td>
		   <td class='forumheader3'>";
    $mytxt .= $frm->form_select_open("method_img");
    $mytxt .= $frm->form_option("Move to the upload folder",1,"move");
    $mytxt .= $frm->form_option("Permanently delete",0,"delete");
    $mytxt .= $frm->form_select_close();
    $mytxt .=     "</td>
    		 </tr>
		 <tr>
		   <td style='text-align: center;' class='forumheader3' colspan='2'>";
    $mytxt .= $frm->form_button("submit", "delete", "Delete");
    $mytxt .= $frm->form_button("submit", "cancel", "Cancel");
    $mytxt .=     "</td>
		 </tr>
    	       </table>";
    $mytxt .= $frm->form_close();

    return $mytxt;
  } else {
    return "The image you are trying to delete does not exist!";
  }
}

/* function to delete an image */
function delete_image($image, $category, $method){
  $sql = new DB;


  if ($method != "move" && $method != "delete"){
    $newcategory = $method;
    $method = "moveup";
  }

  /* check if the image being modified exists */
  if ($sql->db_Select("images", "img_name, img_thumb", "img_id=$image AND img_category=$category")){
    extract($sql->db_Fetch());
  } else {
    return "The image you are trying to delete does not exist!";
  }
  
  $img_path = get_img_path($img_name, $category, false);
  $tmb_path = get_img_path($img_thumb, $category, false);

  switch ($method){
    /* move the image to the upload folder */
    case "move":
      $new_img_path = e_FILE."imagegallery/upload/".$img_name;
      rename($img_path, $new_img_path);
      unlink($tmb_path);
      $sql->db_Delete("images", "img_id=$image AND img_category=$category");

      break;

    /* move the file to the parent category */
    case "moveup":
      $new_img_path = get_img_path($img_name, $newcategory, false);
      $new_tmb_path = get_img_path($img_thumb, $newcategory, false);
      rename($img_path, $new_img_path);
      rename($tmb_path, $new_tmb_path);
      $sql->db_Update("images", "img_category=$newcategory WHERE img_id=$image AND img_category=$category");

      break;
    /* delete the file alltogehter */
    case "delete":
      unlink($img_path);
      unlink($tmb_path);
      $sql->db_Delete("images", "img_id=$image AND img_category=$category");

      break;
  }

  return true;
}
