<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/browse.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");


/*
 * get the vars
 */
list($category, $from, $images, $sortorder, $sortfield) = explode(".", e_QUERY);

$category = intval($category);
$from = intval($from);
$images = intval($images);
$sortorder = intval($sortorder);
$sortfield = strval($sortfield);
$imgsortfield = intval($sortfield[0]);
$catsortfield = intval($sortfield[1]);

/*
 * if a change of view was posted
 */
if (isset($_POST['changeview'])){
  $sortorder = strval($_POST['sortorder'] == "descending" ? "0" : "1");
  $imgsortfield = intval($_POST['imgsortfield']) ? intval($_POST['imgsortfield']) : $imgsortfield;
  $catsortfield = intval($_POST['catsortfield']) ? intval($_POST['catsortfield']) : $catsortfield;
  $images = intval($_POST['images']) ? intval($_POST['images']) : $images;
}

/*
 * check the vars
 */
if ($category <= 0) $category = 1;
if ($images <= 0) $images = $pref['ig_rows_per_page'] * $pref['ig_items_per_row'];
if ($imgsortfield < 0 || $imgsortfield > 2) $imgsortfield = 1;
if ($catsortfield < 0 || $catsortfield > 1) $catsortfield = 1;

/* check if the user is authorized to be here */
if(!is_authorized($category, "view")){
  header("location: browse.php");
  exit;
}

/*
 * get the mode
 */
 $mode = get_default_mode($category, "all");

/*
 * render the categories and images
 */
$cattxt = render_rows("cat", $mode, $category, $from, $images, $sortorder, $catsortfield);
$imgtxt = render_rows("img", $mode, $category, $from, $images, $sortorder, $imgsortfield);

/*
 * now display the page
 */
require_once(HEADERF);
$ns->tablerender("Browsing images", $cattxt.$imgtxt);
require_once(FOOTERF);

/*******************************************************************/

function render_options_bar($url, $type, $category, $total, $from, $items, $sortorder, $sortfield){
  global $pref;
  require_once(e_HANDLER."form_handler.php");
 
  if ($type == "img" && $from > 0) {
    $myfrom = $from - $items;
    if ($myfrom < 0) $myfrom = 0;
    $previous_items = "<a href='$url?$category.$myfrom.$items.$sortorder.$sortfield'>&lt;&lt; previous</a>";
  } else {
    $previous_items = "&lt;&lt; previous";
  }

  if ($type == "img" && ($from + $items) < $total) {
    $myfrom = $from + $items;
    $next_items = "<a href='$url?$category.$myfrom.$items.$sortorder.$sortfield'>next &gt;&gt;</a>";
  } else {
    $next_items = "next &gt;&gt;";
  }

  $frm = new form;
  $options = " sort on";

  if ($type == "img") {
    $options .= $frm->form_select_open("imgsortfield");
    $options .= $frm->form_option("name",($sortfield == 0 ? 1 : 0),0);
    $options .= $frm->form_option("date",($sortfield == 1 ? 1 : 0),1);
    $options .= $frm->form_option("views",($sortfield == 2 ? 1 : 0),2);
    //$options .= $frm->form_option("rating",($sortfield == 3 ? 1 : 0),3);
    $options .= $frm->form_select_close();
  } else {
    $options .= $frm->form_select_open("catsortfield");
    $options .= $frm->form_option("name",($sortfield == 0 ? 1 : 0),0);
    $options .= $frm->form_select_close();
  }

  $options .= " sort order";
  $options .= $frm->form_select_open("sortorder");
  $options .= $frm->form_option("descending",($sortorder == 0 ? 1 : 0),"descending");
  $options .= $frm->form_option("ascending",($sortorder == 1 ? 1 : 0),"ascending");
  $options .= $frm->form_select_close();

  if ($type == "img") {
    $options .= " items per page";
    $options .= $frm->form_select_open("images");
    $n = $pref['ig_items_per_row'] * 3;  $options .= $frm->form_option($n,($items == $n ? 1 : 0),$n);
    $n = $pref['ig_items_per_row'] * 9;  $options .= $frm->form_option($n,($items == $n ? 1 : 0),$n);
    $n = $pref['ig_items_per_row'] * 18; $options .= $frm->form_option($n,($items == $n ? 1 : 0),$n);
    $n = $pref['ig_items_per_row'] * 36; $options .= $frm->form_option($n,($items == $n ? 1 : 0),$n);
    $options .= $frm->form_select_close();
  }

  $options .= $frm->form_button("submit", "changeview", "change");

  $txt .= $frm->form_open("post", "$url?$category.$from.$items.$sortorder.$sortfield");
  $txt .= "<table style='width: 100%;'><tr>";
  if ($type == "img") {
    $txt .= "<td class='forumheader' style='text-align: left;'>$previous_items</td>
    <td class='forumheader' style='text-align: center;'>$options</td>
    <td class='forumheader' style='text-align: right;'>$next_items</td>";
  } else {
    $txt .= "<td class='forumheader' style='text-align: center;'>$options</td>";
  }
  $txt .= "</tr></table>";
  $txt .= $frm->form_close();

  return $txt;
}

/* renders image browse view in row mode */
function render_rows($type, $mode, $category, $from, $items, $sortorder, $sortfield){
  global $pref;
  $sql = new DB;

  /******************/
  /** get the data **/
  /******************/

  if ($type == "img"){
    $ascdesc = $sortorder == 0 ? "DESC" : "ASC";
    $mysortfield = img_id_to_field($sortfield);
    $count = $sql->db_Select("images", "img_id, img_name, img_description, img_author, img_thumb, img_category, img_datestamp", "img_category=$category ORDER BY img_$mysortfield $ascdesc LIMIT $from, $items");
    $header = "Images";
  } else {
    $ascdesc = $sortorder == 0 ? "DESC" : "ASC";
    $mysortfield = cat_id_to_field($sortfield);
    $count = $sql->db_Select("images_category", "category_id, category_name, category_image, category_description, category_class_view", "category_category=$category ORDER BY category_$mysortfield $ascdesc");
    if ($category > 1) $count++;
    $header = "Category's";
  }

  /**************************************************/
  /** if there are images/categories, do something **/
  /**************************************************/

  if ($count && $mode){

    /*
     * what are we rendering
     */
    if ($type == "img") {
      $mymode = $mode['img'];
    } else {
      $mymode = $mode['cat'];
    }

    unset($thumb);
 
    /*
     * make the options bar
     */
    $options = render_options_bar(e_SELF, $type, $category, $count, $from, $items, $sortorder, $sortfield);

    switch ($mymode){
      /**************************/
      /** large thumbnail view **/
      /**************************/
      case 1:
      	$txt .= "<div class='forumheader2'> $header </div>";
	$txt .= "<table style='width: 100%;'><tr><td colspan='".$pref['ig_items_per_row']."'>";
	$txt .= $options;
	$txt .= "</td></tr><tr>";

	$item = 0;
	$count += $count % $pref['ig_items_per_row'];
	$columnwidth = floor(100 / $pref['ig_items_per_row']);

	if ($type == "img" || $category == 1){
	  $i = 0;
	} else {
	  $txt .= "<td>";
	  $txt .= render_cat_parent($category);
	  $txt .= "</td>";
	  $i = 1;
	}

	for (; $i < $count; $i++){

	  $data = $sql->db_Fetch();

	  if ($type == "cat" && !check_class($data['category_class_view'])) continue;

	  if ($item >= $pref['ig_items_per_row']){
	    $txt .= "</tr><tr>";
	    $item = 0;
	  }

	  $txt .= "<td style='width: $columnwidth%;'>";

	  if ($type == "img"){
	    $txt .= render_img($data, $mode['view']);
	  } else {
	    $txt .= render_cat($data);
	  }
	  
	  $txt .= "</td>";

	  $item++;
	}

	$txt .= "</tr><tr><td colspan='".$pref['ig_items_per_row']."'>";
	$txt .= $options;
	$txt .= "</td></tr></table>";
	break;

      /**************************/
      /** list with thumbnails **/
      /**************************/
      case 2:
      	$thumb = true;
      /*****************************/
      /** list without thumbnails **/
      /*****************************/
      case 3:
      	if (!isset($thumb)) $thumb = false;
      	$txt .= "<div class='forumheader2'> $header </div>";
	$txt .= "<table style='width: 100%;'><tr><td>";
	$txt .= $options;
	$txt .= "</td></tr>";

	if ($type == "img" || $category == 1){
	  $i = 0;
	} else {
	  $txt .= "<tr><td>";
	  $txt .= render_list_cat_parent($thumb, $category);
	  $txt .= "</td></tr>";
	  $i = 1;
	}

	for (; $i < $count; $i++){

	  $data = $sql->db_Fetch();

	  if ($type = "cat" && !check_class($data['category_class_view'])) continue;

	  $txt .= "<tr><td>";

	  if ($type == "img"){
	    $txt .= render_list_img($thumb, $data, $mode['view']);
	  } else {
	    $txt .= render_list_cat($thumb, $data);
	  }
	    
	  $txt .= "</td></tr>";
	}
      
	$txt .= "</table>";
	break;
      /***************************************/
      /** dropdown list ONLY for categories **/
      /***************************************/
      case 4:
	require_once(e_HANDLER."form_handler.php");
	$frm = new form;

	$txt .= "<table style='width: 100%;'><tr><td class='forumheader2' style='width: 30%'>Jump to (sub)category</td><td class='forumheader2'>";
	$txt .= "<select name='categoryjump' onChange='urljump(this.options[selectedIndex].value)' class='tbox'>";
	$txt .= $frm->form_option("Select one", 0, "");

	for ($i = 0; $i < $count; $i++){
	  extract($sql->db_Fetch());
	 
	  if (!check_class($category_class_view)) continue;
	 
	  $txt .= $frm->form_option($category_name, 0, "browse.php?$category_id");
	}

	$txt .= $frm->form_select_close();
	$txt .= "</td></tr></table>";
	
        break;
    }

  /********************************************/
  /** return nothing if no images/categories **/
  /********************************************/

  } else {
    $txt = render_none($type, $category);
  }

  /* return our generated text */
  return $txt;
}


function render_none($type, $category){
  if ($type == "img")
    return "<div class='forumheader2'> No images found </div>";
  else {
    return "<div class='forumheader2'> No categories found </div>";
  }
}

function render_img($imgdata, $viewmode){
  global $pref;
  $gen = new convert;
  extract($imgdata);

  if ($img_id) {
    $img_datestamp = $gen->convert_date($img_datestamp, "short");
    $img_thumb = get_img_url($img_thumb, $img_category);

    $txt = "<table class='fborder' style='margin: 10px; padding: 3px; text-align: center;'>
    <tr><td><a href='view.php?$img_id.$viewmode'><img style='border: 0; width: 180px; height: 144px;' src='$img_thumb' alt='$img_name' /></a></td></tr>
    <tr><td class='mediumtext'>$img_name</td></tr>
    <tr><td class='smallblacktext'>posted by $img_author on $img_datestamp</td></tr>
    </table>";
  }
  
  return $txt;
}

function render_list_img($thumb, $imgdata, $viewmode){
  global $pref;
  $gen = new convert;
  extract($imgdata);

  if ($img_id){
    if ($thumb) {
      $img_thumb = get_img_url($img_thumb, $img_category);

      $txt = "
      <table style='width: 100%;'>
	<tr>
	  <td class='forumheader2' rowspan='2'><a href='view.php?$img_id.$viewmode'><img style='border: 0; width: 90px; height: 67px;' src='$img_thumb' alt='$img_name' /></a></td>
	  <td class='forumheader3' style='width: 100%;'>$img_name</td>
	</tr>
	<tr>
	  <td class='forumheader3'>$img_description</td>
	</tr>
      </table>";
    } else {
      $txt = "
      <table style='width: 100%;'>
	<tr>
          <td class='forumheader3' style='width: 5%;'><a href='view.php?$img_id.$viewmode'>view</a></td>
	  <td class='forumheader3' style='width: 15%;'>$img_name</td>
	  <td class='forumheader3' style='width: 80%;'>$img_description</td>
	</tr>
      </table>";
    }
  }

  return $txt;
}

function render_cat($catdata){
  global $pref;
  extract($catdata);

  $category_image = get_img_url($category_image, 0);

  if ($category_id) {
    $txt = "<table class='fborder' style='margin: 10px; padding: 3px; text-align: center;'>
    <tr><td><a href='browse.php?$category_id'><img style='border: 0; width: 180px; height: 135px;' src='$category_image' alt='$category_name' /></a></td></tr>
    <tr><td class='mediumtext'>$category_name</td></tr>
    <tr><td class='smallblacktext'>$category_description</td></tr>
    </table>";
  }
  
  return $txt;
}

function render_cat_parent($category){
  global $sql;
  $sql->db_Select("images_category", "category_category", "category_id=$category");
  list ($category_category) = $sql->db_Fetch();

  $txt = "<table class='fborder' style='margin: 10px; padding: 3px; text-align: center;'>
  <tr><td><a href='browse.php?$category_category'><img style='border: 0; width: 180px; height: 135px;' src='".e_HTTP."e107_plugins/imagegallery/images/folder.png' alt='...' /></a></td></tr>
  <tr><td class='mediumtext'> ... </td></tr>
  <tr><td class='smallblacktext'> Parent category  </td></tr>
  </table>";
  return $txt;
}

function render_list_cat($thumb, $catdata){
  extract($catdata);

  if ($category_id){
    if ($thumb) {
      $category_image = get_img_url($category_image, 0);
      $txt = "
      <table style='width: 100%;'>
	<tr>
	  <td class='forumheader2' rowspan='2'><a href='browse.php?$category_id'>
	    <img style='border: 0; width: 90px; height: 67px;' src='$category_image' alt='$category_name' /></a>
	  </td>
	  <td class='forumheader3' style='width: 100%;'>$category_name</td>
	</tr>
	<tr>
	  <td class='forumheader3'>$category_description</td>
	</tr>
      </table>";
    } else {
      $txt = "
      <table style='width: 100%;'>
	<tr>
	  <td class='forumheader3' style='width: 5%;'><a href='browse.php?$category_id'>view</a></td>
	  <td class='forumheader3' style='width: 15%;'>$category_name</td>
	  <td class='forumheader3' style='width: 80%;'>$category_description</td>
	</tr>
      </table>";
    }
  }

  return $txt;
}

function render_list_cat_parent($thumb, $category){
  global $sql;
  $sql->db_Select("images_category", "category_category", "category_id=$category");
  list ($category_category) = $sql->db_Fetch();

  if ($thumb) {
    $txt = "
    <table style='width: 100%;'>
      <tr>
	<td class='forumheader2' rowspan='2'><a href='browse.php?$category_category'>
	  <img style='border: 0; width: 90px; height: 67px;' src='".e_HTTP."e107_plugins/imagegallery/images/folder.png' alt='...' /></a>
	</td>
	<td class='forumheader3' style='width: 100%;'>...</td>
      </tr>
      <tr>
	<td class='forumheader3'>Parent category</td>
      </tr>
    </table>";
  } else {
    $txt = "
    <table style='width: 100%;'>
      <tr>
	<td class='forumheader3' style='width: 5%;'><a href='browse.php?$category_category'>view</a></td>
	<td class='forumheader3' style='width: 15%;'>...</td>
	<td class='forumheader3' style='width: 80%;'>Parent category</td>
      </tr>
    </table>";
  }
  return $txt;
}
?>
