<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/functions.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

/* make the get_image_size output human readable */
function parseimagedetails($image){
  $types = array(1 => "GIF",
  		 2 => "JPG",
		 3 => "PNG",
		 4 => "SWF",
		 5 => "PSD",
		 6 => "BMP",
		 7 => "TIFF(intel byte order)",
		 8 => "TIFF(motorola byte order)",
		 9 => "JPC",
		 10 => "JP2",
		 11 => "JPX",
		 12 => "JB2",
		 13 => "SWC",
		 14 => "IFF",
		 15 => "WBMP",
		 16 => "XBM");
  list($width, $height, $type, $attr) = getimagesize($image);

  $str = $width."x".$height.", ".$types[$type];
  return $str;
}

function mode_category_list($form_name, $mode){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;

  $txt = $frm->form_select_open($form_name);
  $txt .= $frm->form_option('Display as if no category\'s were found', $mode == '0', '0');
  $txt .= $frm->form_option('Large thumbnails', $mode == '1', '1');
  $txt .= $frm->form_option('List with small thumbnails', $mode == '2', '2');
  $txt .= $frm->form_option('List without thumbnails', $mode == '3', '3');
  $txt .= $frm->form_option('Dropdown list with subcategory\'s', $mode == '4', '4');
  $txt .= $frm->form_select_close();

  return $txt;
}

function mode_image_list($form_name, $mode){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;

  $txt = $frm->form_select_open($form_name);
  $txt .= $frm->form_option('Display as if no images were found', $mode == '0', '0');
  $txt .= $frm->form_option('Large thumbnails', $mode == '1', '1');
  $txt .= $frm->form_option('List with small thumbnails', $mode == '2', '2');
  $txt .= $frm->form_option('List without thumbnails', $mode == '3', '3');
  $txt .= $frm->form_select_close();

  return $txt;
}

function mode_view_list($form_name, $mode){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;

  $txt = $frm->form_select_open($form_name);
  $txt .= $frm->form_option('Image with detailed information', $mode == '1', '1');
  $txt .= $frm->form_option('As the above with previous/next buttons', $mode == '2', '2');
  $txt .= $frm->form_option('Image with technical information', $mode == '3', '3');
  $txt .= $frm->form_option('Standard e107 page with image', $mode == '4', '4');
  $txt .= $frm->form_option('Bare page with image and little information', $mode == '5', '5');
  $txt .= $frm->form_option('Only the image', $mode['view'] == '6', '6');
  $txt .= $frm->form_select_close();

  return $txt;
}

/* create and image url for an image */
function get_img_url($img_name, $img_category){
  $sql = new DB;

  if ($img_category == 0){
    $img_path = "e107_files/imagegallery/category_thumbs/$img_name";
    if (file_exists(e_BASE.$img_path)){
      return e_HTTP.$img_path;
    } else {
      return e_HTTP."e107_plugins/imagegallery/images/no_image.png";
    }
  }
  
  if ($sql->db_Select("images_category", "category_name", "category_id=$img_category")){
    list($category_name) = $sql->db_Fetch();
    $img_path = "e107_files/imagegallery/$img_category-$category_name/$img_name";

    if (file_exists(e_BASE.$img_path)) return e_HTTP.$img_path;
  }

  return e_HTTP."e107_plugins/imagegallery/images/no_image.png";
}

/* create and image path for an image */
function get_img_path($img_name, $img_category, $check_exist = true){
  $sql = new DB;

  if ($img_category == 0){
    $img_path = e_FILE."imagegallery/category_thumbs/$img_name";
    if (file_exists(e_BASE.$img_path)){
      return e_BASE.$img_path;
    } else {
      return e_BASE."e107_plugins/imagegallery/images/no_image.png";
    }
  }
  
  if ($sql->db_Select("images_category", "category_name", "category_id=$img_category")){
    list($category_name) = $sql->db_Fetch();
    $img_path = e_FILE."imagegallery/$img_category-$category_name/$img_name";

    if ($check_exits) {
      if (file_exists($img_path)) return $img_path;
    } else {
      return $img_path;
    }
  }

  return e_BASE."e107_plugins/imagegallery/images/no_image.png";
}

/* check if the user is authorized */
function is_authorized($category_id, $type = "all"){
  global $sql;
  $sql->db_Select("images_category", "category_class_view, category_class_submit, category_class_admin", "category_id=$category_id");
  list($class_view, $class_submit, $class_admin) = $sql->db_Fetch();
  switch ($type){
    case "view": return check_class($class_view);
    case "submit": return check_class($class_submit);
    case "admin": return check_class($class_admin);
    case "all":
    default: return array("view" => check_class($class_view), "submit" => check_class($class_submit), "admin" => check_class($class_admin));
  }
  return check_class($category_class);
}

/* retreive the default mode */
function get_default_mode($category_id, $what = "all"){
  $sql = new DB;
  $sql->db_Select("images_category", "category_mode", "category_id=$category_id");
  list($mode) = $sql->db_Fetch();
  list($view_mode, $img_mode, $cat_mode) = explode(".", $mode);
  switch ($what){
    case "view": return $view_mode;
    case "img": return $img_mode;
    case "cat": return $cat_mode;
    case "all":
    default: return array("view" => $view_mode, "img" => $img_mode, "cat" => $cat_mode);
  }
}

function img_id_to_field($id){
  switch ($id){
    case 0  : return "name";
    case 1  : return "datestamp";
    case 2  : return "views";
    case 3  : return "rating";
    default : return "name";
  }
}

function img_field_to_id($field){
  switch ($field){
    case "name"  : return 0;
    case "date"  : return 1;
    case "views" : return 2;
    case "rating": return 3;
    default: return 0;
  }
}

function cat_id_to_field($id){
  switch ($id){
    case 0  : return "name";
    case 1  : return "views";
    case 2  : return "rating";
    default : return "name";
  }
}

function cat_field_to_id($field){
  switch ($field){
    case "name"  : return 0;
    case "views" : return 1;
    case "rating": return 2;
    default: return 0;
  }
}

?>
