<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/view.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/*************************************************/
/** get the e_QUERY vars and make some defaults **/
/*************************************************/
list($img_id, $mode) = explode(".", e_QUERY);
$img_id = intval($img_id);
$mode = intval($mode);

render_page($img_id, $mode);
if (!$mode) $mode = 1;

/*********************/
/** render the page **/
/*********************/
function render_page($img_id, $mode){
  global $ns;
  $sql = new DB;

  require_once("functions.php");

  /************************/
  /** get the image data **/
  /************************/
  if ($mode <= 3){
    $what = "img_id, img_name, img_description, img_thumb, img_image, img_datestamp, img_category, img_author, img_author_email, img_author_homepage, img_views";
  } else {
    $what = "img_name, img_category, img_image";
  }
  $count = $sql->db_Select("images", $what, "img_id=$img_id");

  /********************************************************/
  /** if the mode was not given use the category default **/
  /********************************************************/
  if ($mode == 0){
    $mode = intval(get_default_mode($img_category, "img"));
  }

  /************************************/
  /* if we have an image to work with */
  /************************************/
  if ($count && $mode){

    require_once(e_HANDLER."rate_class.php");

    /**************************************/
    /** extract the data for ease of use **/
    /**************************************/
    $row = $sql->db_Fetch();

    /*************************************/
    /** check if the user is authorized **/
    /*************************************/
    if (is_authorized($row['img_category'], "view")){
   
      /**********************************/
      /** get the image submitter date **/
      /**********************************/
      if ($mode <= 3){
        $user = explode('.', $row['img_author']);
	if (!$user[0]) {
	  $row['img_author'] = $user[1];
	  $row['img_author_member'] = false;
	} else {
          $sql->db_Select("user", "user_name, user_email, user_homepage, user_id", "user_id='".$user[0]."'");
          $user = $sql->db_Fetch();
	  $row['img_author']          = $user['user_name'];
	  $row['img_author_email' ]   = $user['user_email'];
	  $row['img_author_homepage'] = $user['user_homepage'];
	  $row['img_author_member']   = $user['user_id'];
	}
      }
  
      switch ($mode){
	
	/**************/
	/** detailed **/
	/**************/
	case 1:
	  render_detailed("normal", $row);
	  break;

	/******************************************/
	/** detailed view with prev/next buttons **/
	/******************************************/
	case 2:
	  render_detailed("browse", $row);
	  break;
	  
	/***************************/
	/** technical information **/
	/***************************/
	case 3:
	  render_detailed("tech", $row);
	  break;

	/************************/
	/** only image in page **/
	/************************/
	case 4:
	  render_basic("page", $row['img_name'], $row['img_category'], $row['img_image']);
	  break;

	/*************************/
	/** only image in frame **/
	/*************************/
	case 5:
	  render_basic("frame", $row['img_name'], $row['img_category'], $row['img_image']);
	  break;
	
	/****************/
	/** only image **/
	/****************/
	case 6:
	  render_basic("bare", $row['img_name'], $row['img_category'], $row['img_image']);
	  break;
      }

    } else {
      /*********************************************/
      /** user is not authorized, so tell him/her **/
      /*********************************************/
      global $HEADER, $FOOTER;
      require_once(HEADERF);
      $ns->tablerender("ACCESS DENIED", "ACCESS DENIED, WHAHAHAHAHAHAHAHAAHAH!");
      require_once(FOOTERF);
    }

  } else {
    header("Location: browse.php");
    exit;
  }

}

/**********************************************/
/* renders image in a very basic display mode */
/**********************************************/
function render_basic($type = "bare", $img_name, $img_category, $img_image){
  global $ns;
  $img_url = get_img_url($img_image, $img_category);
  switch ($type){
    /***************************************/ 
    /** bare: redirect to the image alone **/ 
    /***************************************/ 
    case "bare":
      //header("Location: $img_url");
      header('Content-type: image');
      $fd=fopen(get_img_path($img_name, $img_category, true ,'rb');
	while(!feof($fd)) {
	  print fread($fd, 4096);
	}
      fclose($fd);

      exit;

    /***********************************************************/
    /** the image on a page in the site, but without any info **/
    /***********************************************************/
    case "page":
      require(HEADERF);
      $ns->tablerender($img_name, "<img style='text-align: center; border: 0px;' src='$img_url' alt='$img_name' />");
      require(FOOTERF);
      break;

    /***********************************************/
    /** the image on its own page with basic info **/
    /***********************************************/
    case "frame":
      $txt = "<html>
      	<head><title>$img_name</title></head>
	<body>
		<h1>$img_name</h1>
		<img style='border-color: black; border-width: 1px;' src='$img_url' alt='$img_name'></img>
	</body>
     </html>";
     printf($txt);
     exit;
  }
}
  
/* renders a detailed image view */
function render_detailed($type = "normal", $row){ 
  global $ns, $sql;
  /* extract the vars in $row */
  extract($row);

  /* create an object we need to convert datetimestamps */
  $gen = new convert;
  $sql = new DB;

  $img_url = get_img_url($img_image, $img_category);
  if (!strpos($img_url, "no-image.png")) $sql->db_Update("images", "img_views=img_views+1 WHERE img_id=$img_id");

  /* do some processing on the vars to make them suitable for printing */
  $img_datestamp = $gen->convert_date($img_datestamp, "short");

  /* get the rating of this image */
  $rate = new rater;
  $img_rating = $rate->getrating("images", $img_id);
  $img_rating = $img_rating[1]."/".$img_rating[0];

  /* create the bar above the image */
  if ($type == "browse"){
    /* create a bar with prev - img_name - next */
    $myheader =  "<td class='fcaption' style='text-align: left;'>&lt;&lt; previous </td>
		<td colspan='2' class='fcaption' style='text-align: center;'> $img_name </td>
		<td class='fcaption' style='text-align: right;'> next &gt;&gt;</td>";
  } else {
    /* simple header */
    $myheader = "<td colspan='4' class='fcaption'> $img_name </td>";
  }

  /* create the section with the image information*/
  if ($type == "tech"){
    /* display technical information */
  } else {
    /* display normal information */
    /*TODO*/
  }

  /* comments yes or no */
  $sql->db_Select("images_category", "category_allow_comments", "category_id = ".$img_category);
  list($category_allow_comments) = $sql->db_Select;
  if ($category_allow_comments) {
  /*following 2 lines break $txt */
    //require_once("classes/comment_class.php");
    //$cobj = new comment;
    /*TODO add comment stuff (after patch accept)*/
  }

  
  $details = "";
 
  /* render the part of the page with the image */
  $mytxt = 
  "<table width='100%' class='fborder' style='border: 1px solid;' border='0'>
    <tr>
      $myheader
    </tr>
    <tr>
      <td colspan='4' style='text-align: center;'>
        <div style='text-align: center;'><img src='$img_url' style='border:0px;' alt='$img_name' /></div>
      </td>
    </tr>
    <tr>
      <td class='forumheader' colspan='2'>Image Information:</td>
      <td class='forumheader' style='width: 60%'>Description:</td>
      <td class='forumheader' style='white-space: nowrap; text-align: center;'> Rated: $img_rating";
    if (!$rate->checkrated("images", $img_id) && USER) $mytxt .= $rate->rateselect("", "images", $img_id);
    $mytxt .= "</td></tr>
    <tr>
      <td class='forumheader2'> Added on:</td>
      <td class='forumheader3'> $img_datestamp </td>
      <td rowspan='3' colspan='2' class='forumheader3' style='vertical-align: top;'> $img_description</td>
    </tr>
    <tr>
      <td class='forumheader2'> Author: </td>
      <td class='forumheader3'>";
      
  if ($img_author_member) {
    $mytxt .= "<a href='/user.php?id.$img_author_member'><img src='/e107_images/forum/profile.png' alt='profile:' /> $img_author <br />
    <img src='/e107_images/forum/email.png' alt='email:' /> $img_author_email <br />
    <img src='/e107_images/forum/website.png' alt='website:' /> $img_author_homepage </a>";
  } else {
    $mytxt .= "<img src='/e107_images/forum/profile.png' alt='profile:' /> $img_author <br />";
    if ($img_author_email){
      $mytxt .= "<a href='mailto:$img_author_email'><img src='/e107_images/forum/email.png' alt='email:' /> $img_author_email </a><br />";
    }
    if ($img_author_homepage){
      $mytxt .= "<a href='$img_author_homepage'><img src='/e107_images/forum/website.png' alt='website:' /> $img_author_homepage </a>";
    }
  }
  $mytxt .= "</td>
    </tr>
    <tr>
      <td class='forumheader2'> Views: </td>
      <td class='forumheader3'> $img_views </td>
    </tr>
  </table>";
  global $HEADER;
  global $FOOTER;
  require_once(HEADERF);
  $ns->tablerender("Image Details", $mytxt);
  require_once(FOOTERF);
}

?>
